/* A JavaScript implementation of the Secure Hash Algorithm, SHA-256
 * Version 0.3 Copyright Angel Marin 2003-2004 - http://anmar.eu.org/
 * Distributed under the BSD License
 * Some bits taken from Paul Johnston's SHA-1 implementation
 */function safe_add(e,t){var n=(e&65535)+(t&65535),r=(e>>16)+(t>>16)+(n>>16);return r<<16|n&65535}function S(e,t){return e>>>t|e<<32-t}function R(e,t){return e>>>t}function Ch(e,t,n){return e&t^~e&n}function Maj(e,t,n){return e&t^e&n^t&n}function Sigma0256(e){return S(e,2)^S(e,13)^S(e,22)}function Sigma1256(e){return S(e,6)^S(e,11)^S(e,25)}function Gamma0256(e){return S(e,7)^S(e,18)^R(e,3)}function Gamma1256(e){return S(e,17)^S(e,19)^R(e,10)}function core_sha256(e,t){var n=new Array(1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298),r=new Array(1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225),i=new Array(64),s,o,u,a,f,l,c,h,p,d,v,m;e[t>>5]|=128<<24-t%32,e[(t+32>>9<<4)+15]=t;for(var p=0;p<e.length;p+=16){s=r[0],o=r[1],u=r[2],a=r[3],f=r[4],l=r[5],c=r[6],h=r[7];for(var d=0;d<64;d++)d<16?i[d]=e[d+p]:i[d]=safe_add(safe_add(safe_add(Gamma1256(i[d-2]),i[d-7]),Gamma0256(i[d-15])),i[d-16]),v=safe_add(safe_add(safe_add(safe_add(h,Sigma1256(f)),Ch(f,l,c)),n[d]),i[d]),m=safe_add(Sigma0256(s),Maj(s,o,u)),h=c,c=l,l=f,f=safe_add(a,v),a=u,u=o,o=s,s=safe_add(v,m);r[0]=safe_add(s,r[0]),r[1]=safe_add(o,r[1]),r[2]=safe_add(u,r[2]),r[3]=safe_add(a,r[3]),r[4]=safe_add(f,r[4]),r[5]=safe_add(l,r[5]),r[6]=safe_add(c,r[6]),r[7]=safe_add(h,r[7])}return r}function str2binb(e){var t=Array(),n;chrsz=8;for(n=0;n<e.length;n++)e.charCodeAt(n)>127&&(chrsz=16);var r=(1<<chrsz)-1;for(n=0;n<e.length*chrsz;n+=chrsz)t[n>>5]|=(e.charCodeAt(n/chrsz)&r)<<24-n%32;return t}function binb2hex(e){var t=0,n=t?"0123456789ABCDEF":"0123456789abcdef",r="";for(var i=0;i<e.length*4;i++)r+=n.charAt(e[i>>2]>>(3-i%4)*8+4&15)+n.charAt(e[i>>2]>>(3-i%4)*8&15);return r}function hex_sha256(e){return binb2hex(core_sha256(str2binb(e),e.length*chrsz))}function sha256_self_test(){return hex_sha256("message digest")=="f7846f55cf23e14eebeab5b4e1550cad5b509e3348fbc4efa3a1413d393cb650"}var chrsz=8;function affiche_login_secure(){alea_actuel?jQuery("#pass_securise").show():jQuery("#pass_securise").hide()}function informe_auteur(c){informe_auteur_en_cours=!1,eval("c = "+c),c?(alea_actuel=c.alea_actuel,alea_futur=c.alea_futur,jQuery("input#session_remember:not(.modifie)").attr("checked",c.cnx=="1"?"checked":"")):alea_actuel="",c.logo?jQuery("#spip_logo_auteur").html(c.logo):jQuery("#spip_logo_auteur").html(""),affiche_login_secure()}function calcule_hash_pass(e){if((alea_actuel||alea_futur)&&!e.match(/^\{([0-9a-f]{32});([0-9a-f]{32})\}$/i)&&!e.match(/^\{([0-9a-f]{64});([0-9a-f]{64});([0-9a-f]{32});([0-9a-f]{32})\}$/i)&&sha256_self_test()){var t="";t=hex_sha256(alea_actuel+e),t=t+";"+hex_sha256(alea_futur+e),window.calcMD5&&(t=t+";"+calcMD5(alea_actuel+e),t=t+";"+calcMD5(alea_futur+e)),jQuery("input[name=password]").attr("value","{"+t+"}")}}function actualise_auteur(){if(login!=jQuery("#var_login").attr("value")){informe_auteur_en_cours=!0,login=jQuery("#var_login").attr("value");var e=new Date;jQuery.get(page_auteur,{var_login:login,var_compteur:e.getTime()},informe_auteur)}}function login_submit(){actualise_auteur();var e=jQuery("input[name=password]");pass=e.attr("value");if(pass){if(informe_auteur_en_cours&&attente_informe<5)return attente_informe++,jQuery("form#formulaire_login").animeajax().find("p.boutons input").before("."),setTimeout(function(){jQuery("form#formulaire_login").submit()},1e3),!1;alea_actuel||alea_futur?(e.after('<input name="password" type="hidden" value="" />').attr("value",pass),e.attr("name","nothing").attr("value",""),calcule_hash_pass(pass)):informe_auteur_en_cours&&jQuery("input[name=password]").attr("value","")}};